/**********************************************************************************************/
/* VDK_SortOrder.h																			  */
/*                                                                       					  */
/* Valentina SDK    																		  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002															  */
/* All Rights Reserved                                                   					  */
/**********************************************************************************************/

#ifndef __VDK_SortOrder_h 
	#define __VDK_SortOrder_h

#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/FBL.h>
#else
#	include <FBL.h>
#endif // VSDK_FRAMEWORK_STYLE


/**********************************************************************************************/
class  VDK_Field;


/**********************************************************************************************/
class VDK_SortItem
{
	public://///////////////////////////////////////////////////////////////////////////////////
 
 							VDK_SortItem( 	VDK_Field* 	inBaseField,
 											bool		inAscending	= true )
 							{
 								mBaseField 	= inBaseField;
 								mAscending	= inAscending;
 							}
 
		VDK_SortItem*		Clone( void ) {
								return new VDK_SortItem( mBaseField, mAscending );
							}
							
	public://///////////////////////////////////////////////////////////////////////////////////
 
		VDK_Field*			mBaseField;
		bool				mAscending;
};


/**********************************************************************************************/
class VDK_SortOrder : public FBL_Array<VDK_SortItem*>
{
	public://///////////////////////////////////////////////////////////////////////////////////
 
				 			VDK_SortOrder( void ) : 
				 				FBL_Array<VDK_SortItem*>( true )	// owns its items.
				 			{
				 			}

		bool				Include( VDK_Field* inBaseField )
							{
								ulong Count = GetCount();
								for( ulong i = 1; i <= Count ; i++ )
								{
									VDK_SortItem*	pItem = GetItemAt( i );
									if( pItem->mBaseField == inBaseField )
										return true;
								}
								return false; 
							}
};


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif  

